import java.awt.Color;
import java.awt.Graphics;
import java.awt.Graphics2D;
import java.awt.geom.AffineTransform;
import java.awt.geom.Point2D;

import javax.swing.JFrame;
public class Lienzo extends JFrame {
	//Atributos para el contexto grafico
	private double xmin,xmax,ymin,ymax,alto,ancho;
	private Point2D.Double[] puntosReales;
	//Constructor
	public Lienzo(double xmin,double ymin,double alto,double ancho,
			Point2D.Double[] puntos){
		this.xmin=xmin;
		this.xmax=-xmin;
		this.ymin=ymin;
		this.ymax=-ymin;
		this.alto=alto;
		this.ancho=ancho;
		this.puntosReales=puntos;
		this.setTitle("Graficador");
		this.setSize((int) ancho,(int) alto);
		this.setVisible(true);
	}
	@Override //Metodo que se sobreescribe para pintar la parte grafica de un componente
	public void paint(Graphics g) {
		super.paint(g);
		Graphics2D g2=(Graphics2D) g;
		g2.setColor(Color.RED);
		int mitadAncho=(int) (ancho/2.0);
		int mitadAlto=(int) (alto/2.0);
		g2.drawLine(mitadAncho, 0, mitadAncho, (int) alto);
		g2.drawLine(0,mitadAlto, (int) ancho, mitadAlto);
		g2.setColor(Color.BLUE);
		//Para definir la escala entre los puntos reales y los pixeles que los representan
		AffineTransform t = new AffineTransform(); 
		//Se establece la coordenada (0,0) en el centro de la pantalla
		t.translate(ancho/2,alto/2);
		//Se define la escala en x y la escla en y para transformar puntos reales en coordenadas
		//Validas de pixeles
		t.scale (ancho/(xmax-xmin), -alto/(ymax-ymin));
		//Convierte los puntos reales en coordenadas de pixeles
		Point2D [] puntosPixeles = new Point2D[puntosReales.length]; 
		t.transform (puntosReales, 0, puntosPixeles, 0, puntosReales.length);
		//Obtiene los puntos X y Y en un arreglo independiente
		int [] puntosx=new int[puntosReales.length];
		int [] puntosy=new int[puntosReales.length];
		for (int i=0;i<puntosPixeles.length;i++) {
			puntosx[i]=(int) puntosPixeles[i].getX();
			puntosy[i]=(int) puntosPixeles[i].getY();
		}
		//Dibuja un poligono uniendo los puntos con lineas sin cerrarlo
		g2.drawPolyline(puntosx, puntosy, puntosx.length);
		}
}
